/******************************************

    "differentiate.cpp" - Differentiates function at a given point
    Copyright (C) 2014  Animesh Patel

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

******************************************/

#include "fparser.hh"
#include<iomanip>
#include <iostream>
#include <string>
using namespace std;

int main()
{
    string function;
    double minx;
    FunctionParser fparser;

    fparser.AddConstant("pi", 3.1415926535897932);

    while(true)
    {
        cout << "f(x) = ";
        getline(cin, function);
        if(cin.fail()) return 0;

        int res = fparser.Parse(function, "x");
        if(res < 0) break;

        cout << string(res+7, ' ') << "^\n"
                  << fparser.ErrorMsg() << "\n\n";
    }

    cout << "Enter point : ";
    cin >> minx;

    if(cin.fail()) return 0;

    double h=0.000001;
    double t=minx+h;
    double u=minx;

    double p;
    p=(fparser.Eval(&t)-fparser.Eval(&u))/h;
	int v;
    v=fparser.EvalError();
    if(v!=0)
        {
            switch (v)
			{
				case 1: cout << "Error : Division by zero\n";
						return 0 ;
				case 2: cout << "Error : Square root of negative number\n";
						return 0 ;
				case 3: cout << "Error : Logarithm of negative value or zero\n";
						return 0 ;
				default: cout << "Error : Illegal value\n";
						return 0 ;
			}
        }
     else{
    cout<<"Value of the f'(x) at "<<minx<<" : "<<p<<endl;}

    return 0;
}
