/******************************************

    "findroots.cpp" - Finds roots of function
    Copyright (C) 2014  Animesh Patel

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

******************************************/

#include "fparser.hh"
#include<iomanip>
#include <iostream>
#include <string>
using namespace std;

int main()
{
    string function;
    double minx, maxx, step;
    FunctionParser fparser;

    fparser.AddConstant("pi", 3.1415926535897932);

    while(true)
    {
        cout << "f(x) = ";
        getline(cin, function);
        if(cin.fail()) return 0;

        int res = fparser.Parse(function, "x");
        if(res < 0) break;

        cout << string(res+7, ' ') << "^\n"
                  << fparser.ErrorMsg() << "\n\n";
    }


    if(cin.fail()) return 0;
    double x=1;double h=0.0000001,t,u,p,q;
	int err = 0 ;

	cout << "Enter an approximate root : " ;

	cin >> x ;
    for(int i=0;i<30000;i++){
    t=x+h;
    u=x;
    p=(fparser.Eval(&t)-fparser.Eval(&u))/h;
    q=fparser.Eval(&x);

	err = fparser.EvalError();

	if (err != 0)
		{
			switch (err)
			{
				case 1: cout << "Error : Division by zero\n";
						return 0 ;
				case 2: cout << "Error : Square root of negative number\n";
						return 0 ;
				case 3: cout << "Error : Logarithm of negative value or zero\n";
						return 0 ;
				default: cout << "Error : Illegal value\n";
						return 0 ;
			}
		}
    x=x-(q/p);
    }
    cout<<"One of the root of f(x) : "<<x<<endl;
    return 0;
}
