/******************************************

    "headers.h" - header file for MaSH
    Copyright (C) 2014  Abhishek Guha

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

******************************************/

# include <iostream>
# include <fstream>
# include <sys/stat.h>
# include <cerrno>
# include <unistd.h>
# include <sys/types.h>
# include <sys/wait.h>
# include <cstring>
# include <cstdio>
# include <cstdlib>
# include <signal.h>
# include <termios.h>
# include <fcntl.h>
# include <readline/readline.h>
# include <readline/history.h>

# define MAX 1024
# define PIPE_FOUND 1
# define REDIRECT_FOUND 2
# define EXIT -512

using namespace std ;

static const char *shell_version = {"MaSH, version 0.3.14(1)-release (x86_64-pc-linux)\nCopyright (C) 2014 Free Software Foundation, Inc. \nLicense GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\n\nThis is free software; you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law."} ;

static const char *builtins[5] = {"exit", "cd", "version", "history", "math"} ;

void change_directory (char **) ;

void pipe_command (char **, char **) ;

void init_shell () ;

void redirect_command (char **, char **) ;

int parse_cmd (char *, char **, char **, char **) ;

int run_cmd (char **) ;

int exit_mash () ;

int match (char *) ;

int run_builtins (char **) ;

char * trim_space (char *) ;

char * replace (char *, char) ;

void show_history (char **) ;

void history_command (char *) ;

void run_math_cmd (char **) ;

void set_init_dir () ;

void password () ;

void print_welcome () ;

static void sigchld_hdl (int sig) ;
